#include <string>
#include <vector>

#include "common.hh"
#include "SRNode.hh"
#include "Token.hh"
#include "RENode.hh"
#include "Symbol.hh"

string SRNode::toString() const
{
  return "SRNode[ . " + token->toString() + " " + next->toString() + " ]";
}

string SRUnion::doString(string indent) const
{
  /*
  //vector<string>* ss = new vector<string>();
  
  string s = "";
  
  if(nodes==0) return s;
  for(list<SRNode*>::iterator 
	i = nodes->begin(),
	z = nodes->end();
      i!=z; ++i)
    {
      SRNode * node = *i;
      if(node->getToken()) cout << indent << node->getToken()->toVISL() << " {\n";
      if(node->getNext()) node->getNext()->doString(indent+"  ");
      cout << indent << "}\n";
    }
    return s+"";*/
  return "";
}

string SRUnion::toString() const
{
  return "SRUnion[...]";//doString("");
}

vector<RENode*>* SRUnion::appendMatches(Tree * tree, RENodeI ni, Symbol * literal, vector<RENode*>* matches = 0) const
{
  if(!matches) matches = new vector<RENode*>();

  if(nodes)
    for(list<SRNode*>::iterator 
	  i = nodes->begin(),
	  z = nodes->end();
	i!=z; ++i)
      {
	(*i)->appendMatches(tree, ni, literal, matches);
      }
  return matches;
}

vector<RENode*>* SRNode::appendMatches(Tree * tree, RENodeI ni, Symbol * literal, vector<RENode*>* matches = 0) const
{
  if(!matches) matches = new vector<RENode*>();
  RENode * parent = (*ni);
  
  // skipping punctuation symbol?
  if(token->isPunctuation() && !literal->isPunctuation() && getNext())
    {
      getNext()->appendMatches(tree, ni, literal, matches);
    }
  else
    {
      vector<Token*>* tokens = token->appendMatches(literal);
  
      for(vector<Token*>::iterator 
	    i = tokens->begin(),
	    z = tokens->end();
	  i!=z;
	  ++i)
	{
	  RENode * node = new RENode(next, parent, literal, (SRNode*) this, *i);
	  matches->push_back(node);
	}
      delete tokens;
    }
  
  return matches;
}

bool SRNode::isComplete() const
{ 
  // return (((next->getNodes()==0)) && ((token->getPrevious())==0)); 
  bool complete = (((next->getNodes()==0)) && ((token->getPrevious())==0));
  if(complete) return true;
  if(token->getPrevious()!=0) return false;
  
  // a node with just unmatched punctuation tokens to the right is also considered complete.
  SRUnion * n = next;
  while( n->getNodes()!=0 && 
	 (*(n->getNodes()->begin()))->getToken()->isPunctuation() )
    {
      n = (*(n->getNodes()->begin()))->getNext();
    }
  return n->getNodes() == 0;
}
